#include <opencv2/core.hpp> 
#include <opencv2/highgui.hpp> 
#include <opencv2/imgproc.hpp>
using namespace cv; 

int main(){

  namedWindow( "Przyklad 2 - okno 1 - obraz pierwotny", WINDOW_AUTOSIZE );  		// utworzenie okna o nazwie Przyklad 2 - okno 1 - obraz pierwotny
  Mat image= imread("systemyMultimedialne.jpg"); 
  if (!image.data) {
    perror("Wystapil blad przy wczytywaniu obrazka systemyMultimedialne.jpg!");
    destroyWindow( "Przyklad 2 - okno 1 - obraz pierwotny" );  				// zniszczenie okna    
    return 1;
  }
  imshow("Przyklad 2 - okno 1 - obraz pierwotny", image); 				// wyswietlenie obrazka w oknie o nazwie PPrzyklad 2 - okno 1 - obraz pierwotny
  
  namedWindow("Przyklad 2 - okno 2 - blur", WINDOW_AUTOSIZE );
  Mat image2(image.rows,image.cols, CV_8UC3, Scalar(0,0,0));// utworzenie nowego obrazka o rozmiarze obrazka image (najpierw podajemy liczbe wierszy, potem kolumn)
  
  if(!image2.data){
    perror("Wystapil blad przy tworzeniu obrazu przechowujacego przeksztalcony obraz!");
    destroyWindow( "Przyklad 2 - okno 1 - obraz pierwotny" );  				// zniszczenie okna    
    destroyWindow( "Przyklad 2 - okno 2 - blur" );  
    return 1;
  } 

  GaussianBlur( image, image2, Size( 15, 15 ), 0, 0 );	// zastosowanie rozmycia gaussowskiego do image, wynik zostanie zapamietany w image2
  imshow("Przyklad 2 - okno 2 - blur", image2);  
  
  //====== wykrywanie krawedzi: =======
  // w celu wykrycia krawedzi funkcja cvCanny trzeba przekonwertowac obraz do odcieni szarości
  Mat imageBW(image2.rows,image2.cols, CV_8UC1, Scalar(0,0,0));  // utworzenie obrazu w odcieniach szarosci
  Mat edgesImage(image2.rows,image2.cols, CV_8UC1, Scalar(0,0,0));  
  if(!imageBW.data || !edgesImage.data){
    perror("Wystapil blad przy Tworzeniu obrazu przechowujacego przeksztalcony obraz!");    
    destroyWindow( "Przyklad 2 - okno 1 - obraz pierwotny" );  				// zniszczenie okna    
    destroyWindow( "Przyklad 2 - okno 2 - blur" );  
    return 1;
  } 
  cvtColor(image2, imageBW, CV_BGR2GRAY);  // skopiowanie obrazu kolorowego do obrazu z odcieniami szarosci (konwersja na odcienie szarosci)
  Canny( imageBW, edgesImage, 0.3, 0.8);  // wykrycie krawędzi
  //====================================
  namedWindow( "Przyklad 2 - okno 3 - krawedzie", CV_WINDOW_AUTOSIZE );
  
  imshow("Przyklad 2 - okno 3 - krawedzie", edgesImage);   

  waitKey(0); 						// wstrzymanie programu do nacisniecia klawisza ESC
  destroyWindow( "Przyklad 2 - okno 1 - obraz pierwotny" );  				// zniszczenie okna
  destroyWindow( "Przyklad 2 - okno 2 - blur" );  
  return 0;
}
