#include <opencv/cv.h>
#include <opencv/highgui.h>

int main(){

  cvNamedWindow( "Przyklad 2 - okno 1 - obraz pierwotny", CV_WINDOW_AUTOSIZE );  		// utworzenie okna o nazwie Przyklad 2 - okno 1
  IplImage* image = cvLoadImage("systemyMultimedialne.jpg"); 	// wczytanie obrazka z pliku
  if(image==NULL){
    perror("Wystąpił błąd przy wczytywaniu obrazka systemyMultimedialne.jpg!");
    cvDestroyWindow( "Przyklad 2 - okno 1 - obraz pierwotny" );  				// zniszczenie okna    
    return 1;
  }
  cvShowImage("Przyklad 2 - okno 1 - obraz pierwotny", image); 				// wyświetlenie obrazka w oknie o nazwie Przyklad 2 - okno 1
  cvNamedWindow( "Przyklad 2 - okno 2 - blur", CV_WINDOW_AUTOSIZE );  
  IplImage* image2 = cvCreateImage( cvGetSize(image), image->depth, image->nChannels  ); // utworzenie nowego obrazka o rozmiarze obrazka image
  if(image2==NULL){
    perror("Wystąpił błąd przy Tworzeniu obrazu przechowującego przekształcony obraz!");
    cvReleaseImage( &image ); 
    cvDestroyWindow( "Przyklad 2 - okno 1 - obraz pierwotny" );  				// zniszczenie okna    
    cvDestroyWindow( "Przyklad 2 - okno 2 - blur" );  
    return 1;
  } 
  cvSmooth( image, image2, CV_GAUSSIAN, 15, 5 );			// zastosowanie rozmycia gaussowskiego do image, wynik zostanie zapamiętany w image2
  cvShowImage("Przyklad 2 - okno 2 - blur", image2);  
  
  //====== wykrywanie krawędzi: =======
  // w celu wykrycia krawędzi funkcją cvCanny trzeba przekonwertować obraz do odcieni szarości
  IplImage* imageBW = cvCreateImage(cvGetSize(image2), IPL_DEPTH_8U, 1);  // utworzenie obrazu w odcieniach szarości
  IplImage* edgesImage = cvCreateImage(cvGetSize(image2), IPL_DEPTH_8U, 1);
  if(imageBW==NULL || edgesImage==NULL){
    perror("Wystąpił błąd przy Tworzeniu obrazu przechowującego przekształcony obraz!");
    cvReleaseImage( &image ); 
    cvReleaseImage( &image2 ); 
    cvReleaseImage( &imageBW ); 
    cvReleaseImage( &edgesImage );     
    cvDestroyWindow( "Przyklad 2 - okno 1 - obraz pierwotny" );  				// zniszczenie okna    
    cvDestroyWindow( "Przyklad 2 - okno 2 - blur" );  
    return 1;
  } 
  
  cvCvtColor(image2, imageBW, CV_BGR2GRAY);  // skopiowanie obrazu kolorowego do obrazu z odcieniami szarości (konwersja na odcienie szarości)
  cvCanny( imageBW, edgesImage, 0.3, 0.8);  // wykrycie krawędzi
  //====================================
  cvNamedWindow( "Przyklad 2 - okno 3 - krawedzie", CV_WINDOW_AUTOSIZE );
  
  cvShowImage("Przyklad 2 - okno 3 - krawedzie", edgesImage);   
  cvWaitKey(0); 						// wstrzymanie programu do naciśniecia klawisza ESC
  cvReleaseImage( &image ); 					// zwolnienie zasobów przydzielonych do obrazka
  cvReleaseImage( &image2 );
  cvReleaseImage( &imageBW );   
  cvReleaseImage( &edgesImage );
  cvDestroyWindow( "Przyklad 3 - okno 1 - obraz pierwotny" );  	// zniszczenie okna
  cvDestroyWindow( "Przyklad 3 - okno 2 - blur" );  		// zniszczenie okna
  cvDestroyWindow( "Przyklad 3 - okno 3 - krawedzie" );  	// zniszczenie okna  
  return 0;
}
